//
//  DataManagerViewController.m
//  DataManager
//
//  Created by wang  chao on 12-1-12.
//  Copyright 2012年 bupt. All rights reserved.
//

#import "DataManagerViewController.h"
#import "DataManager.h"
#import "DataQueue.h"

static DataQueue* queue;

@implementation DataManagerViewController

@synthesize text = _text;

- (IBAction)get:(id)sender{
    //DataManager* dm = [DataManager manager];
    for (int i=0; i<1; i++) {
        [queue getCacheAndValue:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"] handler:^(DataInfo* info,NSError* error){
            if (error) {
                return;
            }
            _text.text = info.data;
            NSLog(@"Got it! cache: %d",info.cache);
        }];
    }
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    queue = [[DataQueue alloc] initWithMaxTask:1];
    queue.isMerge = NO;

    
    DataManager* dm = [DataManager manager];
    //map url
    RestDataMapper* rmapper = [[[RestDataMapper alloc] initWithKey:@"weather"] autorelease];
    rmapper.urlTemplate = @"http://www.google.com/ig/api";
    //set option
    DataOption* option = [[[DataOption alloc] init] autorelease];
    option.needsCache = YES; 
    //option.autoFetch = YES;
    option.setExpireAfter = YES;
    option.expireAfter = 10;
    rmapper.defaultOption = option;
    [rmapper addOption:option forParams:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    //set decoder
    rmapper.decoder = ^(id data){
        id ret = data;
        //decode data here then the data you get will be the decoded data.
        return ret;
    };
    [dm addMapper:rmapper];
    [dm addObserver:self selector:@selector(changed:) forKey:rmapper.key params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
}

- (void)changed:(NSNotification*)noti{
    static NSInteger times = 3;
    NSLog(@"noti: %@",noti);
    if (times <= 0) {
        [[DataManager manager] removeObserver:self forKey:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    }
    times --;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return YES;
}

- (void)dealloc{
    [_text release];
    [super dealloc];
}

@end
