//
//  DataManagerTests.m
//  DataManagerTests
//
//  Created by wang  chao on 12-1-12.
//  Copyright 2012年 bupt. All rights reserved.
//

#import "DataManagerTests.h"
#import "DataManager.h"
#import "DGLogger.h"

@implementation DataManagerTests

- (void)setUp
{
    [super setUp];
    
    _webDone = NO;
    DGLoggerFilter(DR_ALLOW, nil);
    
    DataManager* dm = [DataManager manager];
    //map url
    RestDataMapper* rmapper = [[[RestDataMapper alloc] initWithKey:@"weather"] autorelease];
    rmapper.urlTemplate = @"http://www.google.com/ig/api";
    //set option
    DataOption* option = [[[DataOption alloc] init] autorelease];
    rmapper.defaultOption = option;
    //set decoder
    rmapper.decoder = ^(id data){
        id ret = data;
        //decode data here then the data you get will be the decoded data.
        return ret;
    };
    
    [dm addMapper:rmapper];
    [dm cleanCache];
    // Set-up code here.
}

- (void)tearDown
{
    // Tear-down code here.
    DataManager* dm = [DataManager manager];
    [dm cleanCache];
    [super tearDown];
}


- (void)testGetWebDataAsync{
    DataManager* dm = [DataManager manager];
    [dm getValue:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"] handler:^(DataInfo* info,NSError* error){
        STAssertNotNil(info.data, @"");
        STAssertNil(error, @"");
        _webDone = YES;
    }];
    while (!_webDone) {
        [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:1.0]];
    }
    
    [dm cleanCache:@"weather"];
    DataInfo* info = [dm getCache:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    STAssertNil(info, @"");

}

- (void)testGetWebDataSync{
    DataManager* dm = [DataManager manager];
    DataInfo* info = [dm getValue:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    STAssertNotNil(info, @"");
    
    [dm cleanCache:@"weather"];
    info = [dm getCache:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    STAssertNil(info, @"");
}

- (void)testGetCahce{
    DataManager* dm = [DataManager manager];
    DataInfo* gotData = [[[DataInfo alloc] init] autorelease];
    [dm getValue:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"] handler:^(DataInfo* info,NSError* error){
        gotData.data = info.data;
        STAssertNotNil(info.data, @"");
        STAssertNil(error, @"");
        _webDone = YES;
    }];
    while (!_webDone) {
        [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:1.0]];
    }
    
    DataInfo* info = [dm getCache:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    STAssertNotNil(info, @"");
    STAssertTrue([info.data isEqual:gotData.data], @"");
    [dm cleanCache:@"weather"];
    info = [dm getCache:@"weather" params:[NSDictionary dictionaryWithObject:@"beijing" forKey:@"weather"]];
    STAssertNil(info, @"");
}


@end
