//
//  DataQueue.h
//  WotControl
//
//  Created by wang  chao on 12-3-22.
//  Copyright (c) 2012年 bupt. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DataManager.h"
#import "DataQueueAlgorithm.h"

@interface HandlerHolder : NSObject{
    DataHandler _handler;
}

@property (nonatomic,copy) DataHandler handler;

+ (id)holderWithHandler:(DataHandler)handler;

@end

@interface DataQueueObj : NSObject{
    NSMutableArray* _handlers;
    BOOL _useCache;
    NSString* _key;
    NSDictionary* _params;
    long long _objID;
}

- (id)initWithKey:(NSString*)key params:(NSDictionary *)params handler:(DataHandler)handler useCache:(BOOL)useCache;


@property (nonatomic,readonly) NSMutableArray* handlers;
@property (nonatomic,readonly) BOOL useCache;
@property (nonatomic,readonly) NSString* key;
@property (nonatomic,readonly) NSDictionary* params;
@property (nonatomic,readonly) NSString* keyPath;
@property (nonatomic,readonly) long long objID;


@end

@interface DataQueue : NSObject{
    BOOL _isMerge;
    NSMutableArray* _queue;
    DataQueueAlgorithm* _algorithm;
}

@property (nonatomic,assign) BOOL isMerge;
@property (nonatomic,retain) NSMutableArray* queue;
@property (nonatomic,retain) DataQueueAlgorithm* algorithm;

- (id)initWithMaxTask:(NSInteger)max;

- (void)getValue:(NSString*)key params:(NSDictionary*)params handler:(DataHandler)handler;
- (void)getValue:(NSString*)key params:(NSDictionary*)params handler:(DataHandler)handler useCache:(BOOL)useCache;

//In this method handler may be called twice
//once cahce,once origin value
- (void)getCacheAndValue:(NSString*)key params:(NSDictionary*)params handler:(DataHandler)handler;

@end
