//
//  DataQueueAlgorithm.m
//  DataManager
//
//  Created by wang  chao on 12-3-23.
//  Copyright (c) 2012年 bupt. All rights reserved.
//

#import "DataQueueAlgorithm.h"

@implementation DataQueueAlgorithmObj

@synthesize obj = _obj;

- (void)dealloc{
    [_obj release];
    [super dealloc];
}

@end

@implementation DataQueueAlgorithm

@synthesize waitingQueue = _waitingQueue;
@synthesize runningQueue = _runningQueue;
@synthesize maxTask = _maxTask;

- (id)init{
    if ([super init]) {
        _waitingQueue = [[NSMutableArray arrayWithCapacity:10] retain];
        _runningQueue = [[NSMutableArray arrayWithCapacity:10] retain];
        _maxTask = -1;
    }
    return self;
}

- (NSArray*)addTask:(DataQueueAlgorithmObj *)task{
    NSMutableArray* ret = [NSMutableArray arrayWithCapacity:1];
    if ([_runningQueue count] >= _maxTask && _maxTask >= 0) {
        [_waitingQueue addObject:task];
    }else {
        [_runningQueue addObject:task];
        [ret addObject:task];
    }
    return ret;
}

- (NSArray*)finishTask:(DataQueueAlgorithmObj *)task{
    NSMutableArray* ret = [NSMutableArray arrayWithCapacity:1];
    [_runningQueue removeObject:task];
    if ([_runningQueue count] < _maxTask || _maxTask < 0) {
        if ([_waitingQueue count] > 0) {
            DataQueueAlgorithmObj* obj = [_waitingQueue lastObject];
            [_runningQueue addObject:obj];
            [_waitingQueue removeObject:obj];
            [ret addObject:obj];
        }
    }
    return ret;
}

- (void)dealloc{
    [_waitingQueue release];
    [_runningQueue release];
    [super dealloc];
}

@end
